' === serinFromPi.bas ====================================================

' This program receives serial strings from Pi.
' Run this program first; then run serialOutToAx.py on the Pi.

' === Directives ===
  #com 3                               'specify serial port
  #picaxe 08M2                         'specify processor
  #terminal 38400                      'open the terminal window
  #no_data                             'save time downloading
  		
' === Constants ====
  symbol rxPin = C.2                   'connected to GPIO 14 on Pi
  symbol txPin = C.1                   'connected to GPIO 15 on Pi
  
' === Variables ====
  symbol chr = b0
	
'==== Begin Main Program =================================================
dirsC = %00010011                      'C.2, C.3, & C.5 are inputs 
setfreq m32

' The next statement is blocking. It waits for, and then discards the
' "garbage" character that's produced by opening the Pi serial port.

serin rxPin,T9600_32,@bptrinc

do
  bptr = 30                            'initialize the byte pointer

  ' The next statement is blocking; it waits for first char in the string.
  
  serin rxPin,T9600_32,@bptrinc

  ' The next statement includes a 100ms timeout, so it's non-blocking.
  ' It will receive the remaining characters, and then time out.
  ' (It may look strange, but a loop wouldn't be fast enough.)
  ' Make sure it's typed all on one line (no "return" characters)

  serin [100],rxPin,T9600_32, @bptrinc,@bptrinc,@bptrinc,@bptrinc,@bptrinc,@bptrinc,@bptrinc,@bptrinc,@bptrinc,@bptrinc,@bptrinc,@bptrinc,@bptrinc,@bptrinc,@bptrinc,@bptrinc,@bptrinc,@bptrinc,@bptrinc,@bptrinc,@bptrinc

  @bptr = 0                            'use 0 as end of transmission mark
  bptr = 30                            'reset bptr to the first location

  do until @bptr = 0                   'echo received data in terminal
    sertxd (@bptrinc)
  loop

  sertxd (CR,LF)                       'move down to next line
loop